<?php // privacy

$xevery = array (
	3600 	=> sprintf( __( 'hour', 	'MailPress' ), '' ),
	3600*2 	=> sprintf( __( '%1$s hours', 	'MailPress' ), '2' ),
	3600*6 	=> sprintf( __( '%1$s hours', 	'MailPress' ), '6' ),
	3600*12 	=> sprintf( __( '%1$s hours', 	'MailPress' ), '12' ),
	3600*24 	=>          __( 'day', 		'MailPress' ),
); 

if ( !isset( $privacy ) )
{
	$privacy = get_option( MailPress_privacy::option_name );
        if ( !isset( $privacy['batch_mode'] ) ) $privacy['batch_mode'] = 'wpcron';
}
?>
<form name="<?php echo basename(__DIR__); ?>" method="post" class="mp_settings">
	<input type="hidden" name="_tab" value="<?php echo basename(__DIR__); ?>" />
	<table class="form-table">
<!-- Pop3 -->
		<tr class="mp_sep">
			<th class="thtitle"><?php _e( 'Pop3', 'MailPress' ); ?></th>
			<td></td>
		</tr>
<!-- Pop3 server -->
		<tr<?php if ( isset( MP_AdminPage::$err_mess['privacy_pop3_server'] ) ) echo ' class="form-invalid"'; ?>>
			<th><?php _e( 'POP3 Server', 'MailPress' ); ?></th>
			<td class="field">
				<input type="text" name="privacy[pop3][server]" size="25" value="<?php if ( isset( $privacy['pop3']['server'] ) ) echo $privacy['pop3']['server']; ?>" />
			</td>
		</tr>
<!-- Pop3 port -->
		<tr<?php if ( isset( MP_AdminPage::$err_mess['privacy_pop3_port'] ) ) echo ' class="form-invalid"'; ?>>
			<th><?php _e( 'Port', 'MailPress' ); ?></th>
			<td class="field">
				<input type="text" name="privacy[pop3][port]" size="4" value="<?php if ( isset( $privacy['pop3']['port'] ) ) echo $privacy['pop3']['port']; ?>" />
			</td>
		</tr>
<!-- Pop3 username -->
		<tr<?php if ( isset( MP_AdminPage::$err_mess['privacy_pop3_username'] ) ) echo ' class="form-invalid"'; ?>>
			<th><?php _e( 'Username', 'MailPress' ); ?></th>
			<td class="field">
				<input type="text" name="privacy[pop3][username]" size="25" value="<?php if ( isset( $privacy['pop3']['username'] ) ) echo $privacy['pop3']['username']; ?>" />
			</td>
		</tr>
<!-- Pop3 pw -->
		<tr>
			<th><?php _e( 'Password', 'MailPress' ); ?></th>
			<td>
				<input type="password" name="privacy[pop3][password]" size="25" value="<?php if ( isset( $privacy['pop3']['password'] ) ) echo $privacy['pop3']['password']; ?>" />
			</td>
		</tr>

<!-- mailbox -->
		<tr class="mp_sep">
			<th class="thtitle"><?php _e( 'Mailbox', 'MailPress' ); ?></th>
			<td></td>
		</tr>
<!-- subjects words -->
		<tr>
			<th><?php _e( 'Mail subjects', 'MailPress' ); ?></th>
			<td class="field">
				<input type="text" name="privacy[export_word]" size="25" value="<?php echo ( isset( $privacy['export_word'] ) ) ? esc_attr( $privacy['export_word'] ) : 'export'; ?>" <?php if ( isset( MP_AdminPage::$err_mess['privacy_export_word'] ) ) echo ' class="form-invalid"'; ?> />
				<span class="italic"><?php _e( 'one word for export data request', 'MailPress'); ?></span>
				<br />
				<input type="text" name="privacy[erase_word]"  size="25" value="<?php echo ( isset( $privacy['erase_word'] ) )  ? esc_attr( $privacy['erase_word'] )  : 'erase';  ?>" <?php if ( isset( MP_AdminPage::$err_mess['privacy_erase_word'] ) )  echo ' class="form-invalid"'; ?> />
				<span class="italic"><?php _e( 'one word for erase data request', 'MailPress'); ?></span>
			</td>
		</tr>
<!-- cron -->
		<tr class="mp_sep">
			<th class="thtitle"><?php _e( 'Batch', 'MailPress' ); ?></th>
			<td></td>
		</tr>
		<tr>
			<th></th>
			<td>
				<table class="general">
					<tr>
						<td class="pr10">
							<label for="privacy_wp_cron">
								<input type="radio" value="wpcron" name="privacy[batch_mode]" id="privacy_wp_cron" class="submit_batch_privacy tog"<?php checked( 'wpcron', $privacy['batch_mode'] ); ?> />
								&#160;&#160;
								<?php _e( 'Wp_cron', 'MailPress' ); ?>
							</label>
						</td>
						<td class="privacy_wpcron pr10 every toggl6<?php if ( 'wpcron' != $privacy['batch_mode'] ) echo ' hide'; ?>">
							<?php _e( 'Every', 'MailPress' ); ?>
							&#160;&#160;
							<select name="privacy[every]">
<?php MP_AdminPage::select_option( $xevery, $privacy['every'] ?? false );?>
							</select>
							<span class="italic">
<?php
if (MP_addons::is_active('MailPress_wp_cron'))
{
	printf( __('You can check your scheduled jobs, if any, on %1$s', 'MailPress'), sprintf( '<a href="' . MailPress_wp_cron . '" target="_blank">%s</a>', __( 'Tools > Wp_cron', 'MailPress' ) ) );
}
else
{
	printf( __('Activate add-on %1$s, so you can check your scheduled jobs, if any.', 'MailPress'), sprintf( '<a href="' . MailPress_addons . '#MailPress_wp_cron' . '" target="_blank">%s</a>', __( 'Wp_cron', 'MailPress' ) ) );
}
?>
							</span>
						</td>
					</tr>
					<tr>
						<td class="pr10">
							<label for="privacy_other">
								<input type="radio" value="other" name="privacy[batch_mode]" id="privacy_other" class="submit_batch_privacy tog"<?php checked( 'other', $privacy['batch_mode'] ); ?> />
								&#160;&#160;
								<?php _e( 'Other', 'MailPress' ); ?>
							</label>
						</td>
						<td class="privacy_other pr10 toggl6<?php if ( 'other' != $privacy['batch_mode'] ) echo ' hide'; ?>">
							<span class="italic">
								<?php _e( "Don't forget to set up a cron job/scheduled task at required frequency (out of WordPress)", 'MailPress' ); ?><br />
								<?php printf( __( 'url for job : "%1$s"', 'MailPress' ), '<code>' . admin_url( 'admin-ajax.php' ) . "?action=mp_cron&hook=" . MailPress_privacy::process_name . '</code>' ); ?>
							</span>
						</td>
					</tr>
				</table>
			</td>
		</tr>

	</table>

<?php MP_AdminPage::save_button(); ?>

</form>