<?php
class MP_AdminPage extends MP_WP_Admin_page_
{
	const screen		= MailPress_page_settings;
	const capability	= 'MailPress_manage_options';
	const help_url		= 'http://blog.mailpress.org/tutorials/';
	const file			= __FILE__;

	public static $first = true;

	public static $err_mess = array();

//// Help ////

	public static function add_help_tab() 
	{
		global $current_screen;

		$_tabs = self::get_tabs();

		foreach( $_tabs as $_tab => $desc )
		{
			$content = '';

			$file = 'includes/settings/' . $_tab . '/help.php';
			include( $file );

			$current_screen->add_help_tab( array( 'id' => $_tab, 'title' => $desc, 'content' => $content ) );
		}
	}

////  Styles  ////

	public static function print_styles( $s ) 
	{
		$styles = ( is_array( $s ) ) ? $s : array();

		wp_register_style( self::screen, '/' . MP_PATH . 'mp-admin/css/settings.css' );
		$styles[] = self::screen;

		parent::print_styles( $styles );
	}

////  Scripts  ////

	public static function print_scripts( $scripts = array() ) 
	{
		wp_register_script( 'mp-smtp',	'/' . MP_PATH . 'mp-admin/js/settings_smtp.js', array(), false, 1 );

		wp_register_script( self::screen, 	'/' . MP_PATH . 'mp-admin/js/settings.js', array( 'jquery-ui-tabs', 'mp-smtp' ), false, 1 );
		wp_localize_script( self::screen, 'MP_AdminPageL10n', array( 'requestFile' => admin_url( 'admin-ajax.php' ) ) );
		$scripts[] = self::screen;

		wp_register_style( 'mp_icons', 		'/' . MP_PATH . 'mp-admin/css/_icons.css' );
		$styles[] = 'mp_icons';

		parent::print_scripts( $scripts );
	}

	public static function print_styles_icons( $i = array( 'icon', ) ) 
	{
		return parent::print_styles_icons( $i );
	}

////  Misc  ////

	public static function get_tabs()
	{
		global $mp_general;

		$_tabs['general'] = __( 'General', 'MailPress' );

		if ( $mp_general || isset( MP_AdminPage::$pst_['general'] ) )
		{
			if ( has_filter( 'MailPress_Swift_Signer_type' ) )
			{
				$t = apply_filters( 'MailPress_Swift_Signer_type', false );
				if ( $t ) $_tabs['signer_' . strtolower( $t )] = $t;
			}

			$t = apply_filters( 'MailPress_Swift_Connection_type', 'SMTP' );
			$_tabs['connection_' . strtolower( $t )] = $t;
			$_tabs = apply_filters( 'MailPress_settings_tab_connection', $_tabs );

			$_tabs['test'] = __( 'Test', 'MailPress' );

			$_tabs = apply_filters( 'MailPress_settings_tab', $_tabs );

			$_tabs['logs'] = __( 'Logs', 'MailPress' );
		}

		return $_tabs;
	}

	public static function save_button()
	{
		$out  = '<p class="submit"><input type="submit" name="Submit" class="button-primary" value="' . esc_attr( __( 'Save Changes' ) ) . '" /></p>' . "\r\n";

		echo $out;
	}

	public static function logs_sub_form ( $name, $data, $headertext )
	{
		if ( !isset( $data[$name] ) )
		{
			$data[$name] = MailPress::$default_option_logs;
		}

		$xlevel = MP_Log::get_defined_constants();

		$out = '';

		if ( self::$first )
		{
			self::$first = false;

			$out .= '<tr>' . "\r\n";
			foreach( array( __( 'Logs', 'MailPress' ), __( 'Level', 'MailPress' ), __( 'Days', 'MailPress' ), __( 'Last purge', 'MailPress' ), ) as $th )
			{
				$out .= '	<th><strong>' . $th . '</strong></th>' . "\r\n";
			}
			$out .= '</tr>' . "\r\n";
		}

		if ( !isset( $xlevel[$data[$name]['level']] ) ) $data[$name]['level'] = key( array_slice( $xlevel, -1, 1, true) );

		$datepurge = ( empty( $data[$name]['lastpurge'] ) ) ? '' : substr( $data[$name]['lastpurge'],0 , 4 ) . '/' . substr( $data[$name]['lastpurge'],4, 2 ) . '/' . substr( $data[$name]['lastpurge'],6, 2 ); 

		$out .= '<tr class="mp_sep">' . "\r\n";
		$out .= '	<th><strong>' . $headertext . '</strong></th>' . "\r\n";
		$out .= '	<td><select name="logs[' . $name . '][level]">'  . self::select_option( $xlevel, $data[$name]['level']  ?? false,     false ) . '</select></td>' . "\r\n";
		$out .= '	<td><select name="logs[' . $name . '][lognbr]">' . self::select_number( 1, 10,   $data[$name]['lognbr'] ?? false, 1, false ) . '</select></td>' . "\r\n";
		$out .= '	<td>' . $datepurge . '<input type="hidden" name="logs[' . $name . '][lastpurge]" value="' . esc_attr( $data[$name]['lastpurge'] ) . '" /></td>' . "\r\n";
		$out .= '</tr>' . "\r\n";

		echo $out;
	}
}