<?php
class MP_Privacy extends MP_privacy_
{
	public $option_name	= MailPress_privacy::option_name;

	public $class		= __CLASS__;
	public $log_name 	= 'mp_process_privacy';
	public $log_option_name = 'privacy';
	public $log_title 	= 'Privacy Report ( Request in mailbox : %1$s )';

	public $cron_name 	= 'MailPress_schedule_privacy';

	function is_request()
	{
		$tags = array( 'From', 'Subject' );
		$this->pop3->get_headers( $this->message_id, $tags );

		$this->local_log = array();

		$this->has_email();
		$this->has_action_name();


		if ( !$this->action_name || !$this->email_address )
		{
			$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
			foreach( $this->local_log as $local_log ) $this->trace->log( $local_log );
			$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );

			$this->failed();

			$this->pop3->delete( $this->message_id );

			return false;
		}

		$this->pop3->delete( $this->message_id );

		return true;
	}

	function has_email()
	{
		$this->email_address = false;
		$this->name_address  = false;

		// from

		$this->get_tag( 'From' );

		$from = trim( $this->tag );

		if ( empty( $from ) )
		{
			$bm = ' email      ! ??? empty header : From (?) ' . $this->tag;
			$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
			return;
		}

		$froms = explode( ' ', $from );

		if ( is_array( $froms ) && count( $froms ) )
		{
			do {
				$from = array_pop( $froms );
				$from = trim( $from );
				$beg = substr( $from,  0, 1 );
				$end = substr( $from, -1, 1 );
				if ( ( $beg == '<' ) && ( $end == '>' ) ) $from = substr( $from, 1, -1);

				$this->email_address = is_email( $from );

				if ( $this->email_address )
				{
					$bm =  ' email      ! ' . $this->email_address;
					$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
					break;
				}
				
			}while( count( $froms ) );

			if ( !$this->email_address )
			{
				$bm = ' email      ! ??? cannot find email ' . $this->tag;
				$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
				return;
			}
		}
		else
		{
			$this->email_address = is_email( $from );

			if ( !$this->email_address )
			{
				$bm = ' email      ! ??? is_email() false : ' . $from . ' << ' . $this->tag;
				$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
				return;
			}
			else
			{
				$bm =  ' email      ! ' . $this->email_address;
				$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
			}
		}

		if ( count( $froms ) )
		{
			$from = implode( ' ', $froms );
			$from = trim( $from );
			if ( !empty( $from ) )
			{
				$beg = substr( $from,  0, 1 );
				$end = substr( $from, -1, 1 );
				if ( ( $beg == '"' ) && ( $end == '"' ) ) $from = substr( $from, 1, -1);
				$this->name_address = $from;
			}
		}
	}

	function has_action_name()
	{
		$this->action_name = false;

		// subject

		$this->get_tag( 'Subject' );

		$subject = trim( $this->tag );

		if ( empty( $subject ) )
		{
			$bm = ' subject    ! ??? empty header : Subject (!) ';
			$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
			return;
		}

		foreach( $this->requests as $request => $word )
		{
			$bm = ' subject    ! ';

			if ( $this->compare( $subject, $word ) )
			{
				$this->action_name = $request;
				$bm .= $subject . ' =  ' . $word;
				$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
				break;
			}
			else
			{
				$subj = ( strlen( $subject ) > 60 ) ? substr( $subject, 0, 56 ) . ' ...' : $subject;
				$bm .= '??? ' . $word . ' <> ' . $subj;
				$this->local_log[] = '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!';
			}
		}
	}

	function failed()
	{
		$this->failures[] = array( 'message' => $this->pop3->message );
	}
}