<?php
abstract class MP_privacy_ extends MP_WP_db_connect_
{
	public $bt = 132;
	public static $count = array();

	public $failed = array();

	function __construct()
	{
		$this->config = get_option( $this->option_name );
		if ( !$this->config ) return;

		$this->trace = new MP_Log( $this->log_name, array( 'option_name' => $this->log_option_name ) );

		$this->requests = array(	'export_personal_data' => strtolower( $this->config['export_word'] ),
							'remove_personal_data' => strtolower( $this->config['erase_word']  ),
		);

		$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
		$bm = sprintf( $this->log_title, 'delete' );
		$this->trace->log( '!' . str_repeat( ' ', 5 ) . $bm . str_repeat( ' ', $this->bt - 5 - strlen( $bm ) ) . '!' );
		$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
		$bm = " start      !";
		$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );

		$return = $this->process();

		do_action( $this->cron_name );

		$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
		$this->trace->end( $return );
	}

// process
	function process()
	{
		$return = true;
		$pop3 = $this->config['pop3'];

		$this->pop3 = new MP_Swift_Pop3( $pop3['server'], $pop3['port'], $pop3['username'], $pop3['password'], $this->trace );

		$bm = ' connecting ! ' . $pop3['server'] . ':' . $pop3['port'];
		$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );

		if ( $this->pop3->connect() )
		{
			if ( $this->pop3->get_list() )
			{
				foreach( $this->pop3->messages as $this->message_id ) $this->process_message();
			}
			else
			{
				$v = ' *** ALL DONE ***       *** ALL DONE ***       *** ALL DONE *** '; 
				$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
				$this->trace->log( '!' . str_repeat( ' ', 15 ) . $v . str_repeat( ' ', $this->bt -15 - strlen( $v ) ) . '!' );
				$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
				$return = false;
			}
			if ( !$this->pop3->disconnect() ) $return = false;
		}
		else $return = false;

		if ( $return )
		{
/*
			if ( !empty( $this->failures ) ) 
			{
				$this->failures[] = array( 'message' => $this->pop3->message );
			}
*/

			$bm = " end        !";
			$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );
		}
		return $return;
	}

	function process_message()
	{
		if ( !$this->is_request() )
		{
			return;
		}

		$this->mysql_disconnect( $this->class );
		$this->mysql_connect( $this->class );


		$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
		$bm = ' email      ! ' . $this->email_address;
		if ( $this->name_address )
		{
			$bm .= ' ( ' . $this->name_address . ' ) ';
		}
		$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );
		$bm = ' action     ! ' . $this->action_name;
		$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );

		$request_id = wp_create_user_request( $this->email_address, $this->action_name );

		switch(true)
		{
			case ( is_wp_error( $request_id ) ) :
				$bm = ' error      ! ' . $request_id->get_error_message();
				$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );
			break;
			case ( ! $request_id ) :
				$bm = ' error      ! Failed to initiate confirmation request';
				$this->trace->log( '!' . $bm . str_repeat( ' ', $this->bt - strlen( $bm ) ) . '!' );
			break;
			default :
				wp_send_user_request( $request_id );
				$bm = ' success    ! Request mail sent to user (#' . $request_id . ').';
			break;
		}
	
		$this->trace->log( '!' . str_repeat( '-', $this->bt ) . '!' );
	}

	function get_tag( $tag, $numeric = false, $item = 0 )
	{
		$this->tag = false;

		if ( isset( $this->pop3->headers[$tag][$item] ) )
		{
			if ( $numeric && is_numeric( $this->pop3->headers[$tag][$item] ) ) 
			{
				$this->tag = $this->pop3->headers[$tag][$item];
			}
			elseif ( !$numeric )
			{
				$this->tag = $this->pop3->headers[$tag][$item];
			}
		}
	}

	function compare( $a, $b )
	{
		foreach( array( 'a', 'b' ) as $arg )
		{
			$$arg = trim( $$arg );
			$$arg = strtolower( $$arg );
			$$arg = mb_convert_encoding( $$arg, 'utf-8', 'auto' );
		}

		return ( $a == $b );
	}
}